---
title: HTMLMediaElement.textTracks
slug: Web/API/HTMLMediaElement/textTracks
tags:
  - API
  - Audio
  - HTML DOM
  - HTMLMediaElement
  - Media
  - Property
  - Reference
  - Tracks
  - Video
  - Web
  - textTracks
---
<div>{{APIRef("HTML DOM")}}{{draft}}</div>

<p><span class="seoSummary">The read-only <strong><code>textTracks</code></strong> property on {{DOMxRef("HTMLMediaElement")}} objects returns a {{DOMxRef("TextTrackList")}} object listing all of the {{DOMxRef("TextTrack")}} objects representing the media element's text tracks</span>, in the same order as in the list of text tracks.</p>

<p>You can detect when tracks are added to and removed from an <code><a href="/en-US/docs/Web/HTML/Element/audio">&lt;audio&gt;</a></code> or <code><a href="/en-US/docs/Web/HTML/Element/video">&lt;video&gt;</a></code> element using the <code>addtrack</code> and <code>removetrack</code> events. However, these events aren't sent directly to the media element itself. Instead, they're sent to the track list object of the <a href="/en-US/docs/Web/API/HTMLMediaElement" title="The HTMLMediaElement interface adds to HTMLElement the properties and methods needed to support basic media-related capabilities that are common to audio and video."><code>HTMLMediaElement</code></a> that corresponds to the type of track that was added to the element</p>

<p>The returned list is <em>live</em>; that is, as tracks are added to and removed from the media element, the list's contents change dynamically. Once you have a reference to the list, you can monitor it for changes to detect when new text tracks are added or existing ones removed.</p>

<div class="hidden">
<p>See {{SectionOnPage("/en-US/docs/Web/API/TextTrackList", "Event handlers")}} to learn more about watching for changes to a media element's track list.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>textTracks</em> = <em>mediaElement</em>.textTracks;</pre>

<h3 id="Value">Value</h3>

<p>A {{DOMxRef("TextTrackList")}} object representing the list of text tracks included in the media element. The list of tracks can be accessed using array notation, or using the object's <code><a href="/en-US/docs/Web/API/VideoTrackList/getTrackById">getTrackById()</a></code> method.</p>

<p>Each track is represented by a {{DOMxRef("TextTrack")}} object which provides information about the track.</p>

<h2 id="Examples">Examples</h2>

<p>We start with a <code><a href="/en-US/docs/Web/HTML/Element/video">&lt;video&gt;</a></code> that has several <code><a href="/en-US/docs/Web/HTML/Element/track">&lt;track&gt;</a></code> children </p>

<pre class="brush: html">&lt;video controls poster="/images/sample.gif"&gt;
  &lt;source src="sample.mp4" type="video/mp4"&gt;
  &lt;source src="sample.ogv" type="video/ogv"&gt;
  &lt;track kind="captions" src="sampleCaptions.vtt" srclang="en"&gt;
  &lt;track kind="descriptions" src="sampleDescriptions.vtt" srclang="en"&gt;
  &lt;track kind="chapters" src="sampleChapters.vtt" srclang="en"&gt;
  &lt;track kind="subtitles" src="sampleSubtitles_de.vtt" srclang="de"&gt;
  &lt;track kind="subtitles" src="sampleSubtitles_en.vtt" srclang="en"&gt;
  &lt;track kind="subtitles" src="sampleSubtitles_ja.vtt" srclang="ja"&gt;
  &lt;track kind="subtitles" src="sampleSubtitles_oz.vtt" srclang="oz"&gt;
  &lt;track kind="metadata" src="keyStage1.vtt" srclang="en" label="Key Stage 1"&gt;
  &lt;track kind="metadata" src="keyStage2.vtt" srclang="en" label="Key Stage 2"&gt;
  &lt;track kind="metadata" src="keyStage3.vtt" srclang="en" label="Key Stage 3"&gt;
&lt;/video&gt;
</pre>

<p>The <code><em>HTMLMediaElement</em>.textTracks</code> returns a <code>textTracksList</code> thru which we can iterate.  Here we print all the properties of each English track to the console.</p>

<pre class="brush: js">var tracks = document.querySelector('video').textTracks;

for (var i = 0, L = tracks.length; i &lt; L; i++) { /* tracks.length == 10 */
   if (tracks[i].language == 'en') {
      console.dir(tracks[i]);
   }
}
</pre>

<p>{{EmbedLiveSample("Examples", "100%", 150)}}</p>

<h2 id="Properties_Methods">Properties &amp; Methods</h2>

<h3 id="properties">properties</h3>

<dl>
 <dt>length</dt>
 <dd>Returns the number of text tracks in <code id="text-track-api:texttracklist-4">TextTrackList</code> object.</dd>
</dl>

<h3 id="methods">methods</h3>

<dl>
 <dt>getTrackById()</dt>
 <dd>The <dfn><code>getTrackById(<var>id</var>)</code></dfn> method returns the first <code id="text-track-api:texttrack-6">TextTrack</code> in the <code id="text-track-api:texttracklist-9">TextTrackList</code> object that matches the id, or null if there is no match.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#dom-media-texttracks", "HTMLMediaElement.textTracks")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No change from {{SpecName('HTML5 W3C')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "embedded-content-0.html#htmlmediaelement", "HTMLMediaElement.textTracks")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.textTracks")}}</p>

<h2 id="See_Also">See also</h2>

<ul>
 <li>The interface defining it, {{DOMxRef("HTMLMediaElement")}}.</li>
 <li>{{HTMLElement("video")}} and {{HTMLElement("audio")}}</li>
 <li>{{DOMxRef("VideoTrack")}} and {{DOMxRef("VideoTrackList")}}</li>
 <li>{{DOMxRef("AudioTrack")}} and {{DOMxRef("AudioTrackList")}}</li>
 <li>VideoTrackList  <code><a href="/en-US/docs/Web/API/VIdeoTrackList/change_event">change</a></code>, <code><a href="/en-US/docs/Web/API/VideoTrackList/addtrack_event">addtrack</a></code> and <code><a href="/en-US/docs/Web/API/VideoTrackList/removetrack_event">removetrack</a></code> events</li>
 <li>Audio TrackList <code><a href="/en-US/docs/Web/API/AudioTrackList/change_event">change</a></code>, <code><a href="/en-US/docs/Web/API/AudioTrackList/addtrack_event">addtrack</a></code> and <code><a href="/en-US/docs/Web/API/AudioTrackList/removetrack_event">removetrack</a></code> events</li>
</ul>
